;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Super Mario Bros. Scroll (Aka screen doesn't scroll left)	;;
;;or it doesn't to the right if you set the extra bit to 3	;;
;;								;;
;;Also, in a vertical level it disables scrolling upwards	;;
;;and if the extra bit is set it disables downward scrolling	;;
;;								;;
;;By: Chdata/Fakescaper						;;
;;								;;
;;REQUIRES YOU TO INSTALL MY Ram Specfic LR Scroll Disable patch;;
;;If you don't LR Scrolling will kill you			;;
;;								;;
;;Alternatively you can just use Smallhackers LR Hook patch	;;
;;But only if you want to COMPLETELY disable LR scrolling	;;
;;								;;
;;Hint: Use this in LevelASM to not waste a sprite slot		;;
;;(Be sure not to just copy this directly to LevelASM though.)	;;
;;(It requires slight modification if you want to do that.)	;;
;;								;;
;;Uses first extra bit: YES					;;
;;(First time I ever got to say that, thanks Ixtab)		;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;If you use my Ram Specfic LR Scroll Disable patch
;Uncomment this and change the freeram address to the same one you set in that patch

;!Freeram = $7C

print "INIT ",pc
print "MAIN ",pc
IHasLernedThatYouDontNeedThosePreservationsInGenerators:
LDA $71
CMP #$09
BEQ .Endo

LDA $5B
BIT #$01
BNE .VerticaLevel

.ExtraBitCheckForGenerators

;LDA #$01		;Uncomment this if you use the patch I made mentioned above
;STA !Freeram		;Not required for Smallhacker's patch

LDA $18B9
BIT #$40
BNE .NoRightScroll

.NoLeftScroll
JSR .LEFTSMB
RTL

.NoRightScroll
JSR .RIGHTSMB
RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.VerticaLevel
LDA $18B9
BIT #$40
BNE .NoDownScroll

.NoUpScroll
JSR .UPSMB
.Endo
RTL

.NoDownScroll
JSR .DOWNSMB
RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.LEFTSMB
LDA $7B
BMI .IceWave
LDA $7E
CMP #$69
BCC .IceWave
BRA .EnableScrolling

.RIGHTSMB
LDA $7B
BPL .IceWave
LDA $7E
CMP #$85
BCS .IceWave

.EnableScrolling
LDA #$01
STA $1411
RTS

.IceWave
STZ $1411
RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.UPSMB
LDA $7D
BMI .IceWave2		;Branch if Negative (FF)
LDA $80
CMP #$60
BCC .IceWave2		;Branch if Less
LDA $81
BMI .IceWave2
BRA .EnableScrolling2

.DOWNSMB
LDA $7D
BPL .IceWave2		;Branch if Plus (00)
LDA $80
CMP #$7D
BCS .IceWave2		;Branch if More
LDA $81
BCS .IceWave2

.EnableScrolling2
LDA #$01
STA $1412
RTS

.IceWave2
STZ $1412
RTS